/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// EvmFeeEstimate struct for EvmFeeEstimate
type EvmFeeEstimate struct {
	Fast   *EvmFee `json:"fast,omitempty"`
	Medium *EvmFee `json:"medium,omitempty"`
	Slow   *EvmFee `json:"slow,omitempty"`
}

// NewEvmFeeEstimate instantiates a new EvmFeeEstimate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEvmFeeEstimate() *EvmFeeEstimate {
	this := EvmFeeEstimate{}
	return &this
}

// NewEvmFeeEstimateWithDefaults instantiates a new EvmFeeEstimate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEvmFeeEstimateWithDefaults() *EvmFeeEstimate {
	this := EvmFeeEstimate{}
	return &this
}

// GetFast returns the Fast field value if set, zero value otherwise.
func (o *EvmFeeEstimate) GetFast() EvmFee {
	if o == nil || o.Fast == nil {
		var ret EvmFee
		return ret
	}
	return *o.Fast
}

// GetFastOk returns a tuple with the Fast field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EvmFeeEstimate) GetFastOk() (*EvmFee, bool) {
	if o == nil || o.Fast == nil {
		return nil, false
	}
	return o.Fast, true
}

// HasFast returns a boolean if a field has been set.
func (o *EvmFeeEstimate) HasFast() bool {
	if o != nil && o.Fast != nil {
		return true
	}

	return false
}

// SetFast gets a reference to the given EvmFee and assigns it to the Fast field.
func (o *EvmFeeEstimate) SetFast(v EvmFee) {
	o.Fast = &v
}

// GetMedium returns the Medium field value if set, zero value otherwise.
func (o *EvmFeeEstimate) GetMedium() EvmFee {
	if o == nil || o.Medium == nil {
		var ret EvmFee
		return ret
	}
	return *o.Medium
}

// GetMediumOk returns a tuple with the Medium field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EvmFeeEstimate) GetMediumOk() (*EvmFee, bool) {
	if o == nil || o.Medium == nil {
		return nil, false
	}
	return o.Medium, true
}

// HasMedium returns a boolean if a field has been set.
func (o *EvmFeeEstimate) HasMedium() bool {
	if o != nil && o.Medium != nil {
		return true
	}

	return false
}

// SetMedium gets a reference to the given EvmFee and assigns it to the Medium field.
func (o *EvmFeeEstimate) SetMedium(v EvmFee) {
	o.Medium = &v
}

// GetSlow returns the Slow field value if set, zero value otherwise.
func (o *EvmFeeEstimate) GetSlow() EvmFee {
	if o == nil || o.Slow == nil {
		var ret EvmFee
		return ret
	}
	return *o.Slow
}

// GetSlowOk returns a tuple with the Slow field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EvmFeeEstimate) GetSlowOk() (*EvmFee, bool) {
	if o == nil || o.Slow == nil {
		return nil, false
	}
	return o.Slow, true
}

// HasSlow returns a boolean if a field has been set.
func (o *EvmFeeEstimate) HasSlow() bool {
	if o != nil && o.Slow != nil {
		return true
	}

	return false
}

// SetSlow gets a reference to the given EvmFee and assigns it to the Slow field.
func (o *EvmFeeEstimate) SetSlow(v EvmFee) {
	o.Slow = &v
}

func (o EvmFeeEstimate) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Fast != nil {
		toSerialize["fast"] = o.Fast
	}
	if o.Medium != nil {
		toSerialize["medium"] = o.Medium
	}
	if o.Slow != nil {
		toSerialize["slow"] = o.Slow
	}
	return json.Marshal(toSerialize)
}

type NullableEvmFeeEstimate struct {
	value *EvmFeeEstimate
	isSet bool
}

func (v NullableEvmFeeEstimate) Get() *EvmFeeEstimate {
	return v.value
}

func (v *NullableEvmFeeEstimate) Set(val *EvmFeeEstimate) {
	v.value = val
	v.isSet = true
}

func (v NullableEvmFeeEstimate) IsSet() bool {
	return v.isSet
}

func (v *NullableEvmFeeEstimate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEvmFeeEstimate(val *EvmFeeEstimate) *NullableEvmFeeEstimate {
	return &NullableEvmFeeEstimate{value: val, isSet: true}
}

func (v NullableEvmFeeEstimate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEvmFeeEstimate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
